<template>
  <div class="m-card-detail">
    <loader v-if="!murr" />

    <template v-else>
      <div class="m-card-detail__header">
        <div class="m-card-detail__header-avatar">
          <img :src="murr.owner_avatar" :alt="murr.owner_name"
onerror="this.src='http://murrengan.ru/murr-back/media/profile/default_murren_avatar.png'"
          />
        </div>

        <div class="m-card-detail__header-username">
          {{ murr.owner_name }}
        </div>

        <div
          v-if="!isAuthorMurr"
          class="m-card-detail__header-subscribe"
          @click="onToggleSubscribeToMurren"
          :class="{ 'is-subscribe': murr.is_subscriber }"
        >
          {{ murr.is_subscriber ? "подписан" : "подписаться" }}
        </div>

        <div class="m-card-detail__header-action">
          <el-button
            v-if="isAuthorMurr"
            icon="el-icon-delete"
            type="text"
            class="m-card-detail__header-action-delete"
            @click="onDeleteMurr"
          />
        </div>
      </div>

      <h1 class="m-card-detail__title">
        {{ murr.title }}
      </h1>

      <div v-if="murr.cover" class="m-card-detail__cover">
        <img
          :src="murr.cover"
          :alt="`Обложка: ${murr.title}`"
          class="m-card-detail__cover-image"
        />
      </div>

      <div v-if="murr.content" class="m-card-detail__body">
        <template v-for="(el, i) in murr.content">
          <h2
            v-if="el.type === 'header'"
            :key="`header-${i}`"
            v-html="$options.filters.sanitizeHtml(el.data.text)"
            class="m-card-detail__marked-header"
          />

          <p
            v-if="el.type === 'paragraph'"
            :key="`paragraph-${i}`"
            v-html="$options.filters.sanitizeHtml(el.data.text)"
            class="m-card-detail__marked-paragraph"
          />

          <figure
            v-if="el.type === 'image'"
            :key="`image-${i}`"
            class="m-card-detail__marked-figure"
          >
            <img
              :key="`image-${i}`"
              :src="el.data.file.url"
              :alt="`${murr.title} | Картинка #${i}`"
              class="m-card-detail__marked-image"
            />
            <figcaption
              v-if="el.data.caption"
              :key="`caption-${i}`"
              v-text="el.data.caption"
              class="m-card-detail__marked-caption"
            />
          </figure>

          <pre
            v-if="el.type === 'code'"
            :key="`code-${i}`"
            class="m-card-detail__marked-code"
            v-text="el.data.code"
            readonly="yes"
          />
        </template>
      </div>

      <div class="m-card-detail__tags">
        <el-tag
          v-for="tag in murr.tags"
          :key="`tag-${tag}`"
          effect="dark"
          type="info"
          size="small"
          class="m-card-detail__tags-item"
          @click="onGoToTag(tag)"
          v-text="tag"
        />
      </div>

      <div class="m-card-detail__footer">
        <div class="m-card-detail__footer-rating">
          <div class="m-card-detail__rating">
            <el-button
              icon="el-icon-arrow-up"
              type="text"
              class="m-card-detail__rating-like"
              :class="{ active: murr.is_like }"
              @click="onRatingLike"
            />

            <el-button
              type="text"
              class="m-card-detail__rating-counter"
              :class="{
                positive: murr.rating > 0,
                negative: murr.rating < 0,
              }"
            >
              {{ murr.rating }}
            </el-button>

            <el-button
              icon="el-icon-arrow-down"
              type="text"
              class="m-card-detail__rating-dislike"
              :class="{ active: murr.is_dislike }"
              @click="onRatingUnlike"
            />
          </div>
        </div>

        <div class="m-card-detail__footer-sharing">
          <el-button
            icon="el-icon-share"
            type="text"
            class="m-card-detail__footer-sharing-link"
            @click="onCopyMurrLink"
          />
        </div>
      </div>

      <murr-comments :comments-count="murr.comments_count" :murr-id="murr.id" />
    </template>
  </div>
</template>

<script>
import { mapActions, mapGetters } from "vuex";
import MurrComments from "../murr_comment/MurrComments.vue";
import * as type from "./store/type.js";
import { MURREN_SUBSCRIBE } from "../murren/store/type.js";

import { copyToBuffer } from "../../utils/helpres.js";

export default {
  name: "MurrCardDetail",

  components: {
    MurrComments,
  },

  props: {
    murrCardId: {
      type: Number,
      default: null,
    },
  },

  data() {
    // Define the entry point
    // If it came through a modals, we take data through the context
    const murrID = this.murrCardId ?? this.$route.params.id;

    return {
      murrID,
      isPanelShow: false,
    };
  },

  async created() {
    const { success } = await this.$store.dispatch(type.MURR_CARD_FETCH_ONE, {
      murrID: this.murrID,
    });

    if (!success) {
      this.$router.push("/404");
    }
  },

  computed: {
    ...mapGetters(["murr"]),

    isAuthorMurr() {
      return this.murr?.owner === this.$store.getters.currentMurren?.id;
    },

    currentUrl() {
      return `${window.location.origin}/murr_card/${this.murrID}`;
    },

    isModalLoad() {
      return !!this.murrCardId;
    },

    isMurrenAuthorized() {
      return !!this.$store.getters.currentMurren;
    },
  },

  methods: {
    ...mapActions({
      notification: "popUpMessage",
      handlerSignInModal: "changeShowLoginForm_actions",
    }),

    async ratingAction(action) {
      const { success, data } = await this.$store.dispatch(action, {
        murrID: this.murr.id,
      });

      if (success) {
        this.$store.commit(type.MURR_CARD_SET, data);

        // Changed the rating status for the murr list
        this.$store.commit(type.MURR_CARDS_UPDATE, {
          murrId: this.murr.id,
          updateField: {
            is_dislike: data.is_dislike,
            is_like: data.is_like,
            likes: data.likes,
            dislikes: data.dislikes,
            rating: data.rating,
          },
        });

        if (this.targetPage === "myLikes") {
          this.$store.commit(type.MURR_CARDS_REMOVE, this.murr.id);
        }
      }
    },

    async onToggleSubscribeToMurren() {
      const { success, data } = await this.$store.dispatch(MURREN_SUBSCRIBE, {
        username: this.murr.owner_name,
      });

      if (success) {
        let notificationMsg;

        // Changed the button subscribe status for the murr detail
        this.$store.commit(type.MURR_CARD_SET, {
          ...this.murr,
          is_subscriber: data.is_subscriber,
        });

        // Changed the button subscribe status for the murr list
        this.$store.commit(type.MURR_CARDS_CHANGE_SUBSCRIBER_STATUS, {
          murrenID: this.murr.owner,
          isSubscriber: data.is_subscriber,
        });

        if (data.is_subscriber) {
          notificationMsg = `Вы успешно подписались на ${this.murr.owner_name} 😊`;
        } else {
          notificationMsg = `Вы успешно отписались от ${this.murr.owner_name} 😟`;
        }

        this.notification({
          message: notificationMsg,
          type: "success",
        });
      }
    },

    async handlerDeleteMurrCard() {
      const murrID = this.murr.id;

      const { success, message } = await this.$store.dispatch(
        type.MURR_CARD_DELETE,
        {
          murrID,
        }
      );

      if (success) {
        this.notification({ message, type: "success" });

        if (this.isModalLoad) {
          // Clear murr cards
          this.$store.commit(type.MURR_CARDS_REMOVE, murrID);

          this.$store.commit("modal/close");
        } else {
          this.$router.push({ name: "home" });
        }
      } else {
        this.notification({ message, type: "warning" });
      }
    },

    onRatingLike() {
      if (!this.isMurrenAuthorized) {
        this.notAuthenticatedRatingNotification();
        return;
      }

      this.ratingAction(type.MURR_CARD_LIKED);
    },

    onRatingUnlike() {
      if (!this.isMurrenAuthorized) {
        this.notAuthenticatedRatingNotification();
        return;
      }

      this.ratingAction(type.MURR_CARD_UNLIKED);
    },

    onCopyMurrLink() {
      copyToBuffer(this.currentUrl);

      this.isPanelShow = false;

      this.notification({
        message: `Линка на мурр скопирована 😊`,
        type: "success",
      });
    },

    onDeleteMurr() {
      this.$confirm("Точно удалить мурр?", "Внимание!", {
        confirmButtonText: "Да",
        confirmButtonClass: "murr-button__danger bigBtn",
        cancelButtonText: "Отмена",
        cancelButtonClass: "murr-button__primary bigBtn",
        customClass: "modal-main",
        type: "warning",
      }).then(this.handlerDeleteMurrCard);
    },

    notAuthenticatedRatingNotification() {
      this.notification({
        message: `Залогинься и сможешь оценивать`,
        type: "success",
      });

      this.handlerSignInModal();
    },

    onGoToTag(tag) {
      // TODO: go tags filter
      // eslint-disable-next-line no-console
      console.log("go tag", tag);
    },
  },

  beforeDestroy() {
    this.$store.commit(type.MURR_CARD_CLEAR);
  },
};
</script>
